#include "DB.h"

void DB::Print(const char* s)
{
	while (*s != 0)
	{
		_putch(*s);
		*s++;
	}
}

void DB::Read(char* buffer, const int size)
{
	int index = 0;
	int counter = 0;
	char ch;

	ch = _getch();

	while (ch != 13 && index < size - 1)
	{
		if (ch == '\b' && counter > 0)
		{
			_putch(ch);
			_putch(' ');
			_putch(ch);
			index -= 1;
			buffer -= 1;
			counter -= 1;
		}
		else if (ch != '\b' || counter != 0)
		{
			_putch(ch);
			*buffer = ch;
			index++;
			buffer++;
			counter += 1;
		}
		ch = _getch();
	}
	*buffer = 0;
	_putch('\n');
}

void DB::Clear()
{
	size = -1;
	List[MAX] = {};
	for (int i = 0; i < MAX; i++)
	{
		*List[i].Name = {};
		List[i].Value = -1;
	}
}

DB::DB()
{

}

DB::~DB()
{
}

void DB::Add(Data data)
{
	if (size < MAX)
	{
		if (size == -1)
			size = 0;

		char* ch = List[size].Name;

		char* pos = data.Name;
		for (; *pos != 0; pos++, ch++)
		{
			*ch = *pos;
		}
		//Add 0 to the End
		*ch = *pos;
		List[size].Value = data.Value;
		size += 1;
	}
}

void DB::Save()
{
	if (size > 0)
	{
		char fileName[LengthOfFileName] = {};
		Print("Enter file name: ");
		Read(fileName, LengthOfFileName);

		std::ofstream out(fileName, std::ofstream::binary);

		for (int i = 0; i < size; i++)
		{
			Data data = List[i];
			out.write(reinterpret_cast<char*>(&data), sizeof(Data));
		}
		Clear();
		out.close();
	}
	else
	{
		Print("There is no data!\n");
	}
}

void DB::Load()
{
	char fileName[LengthOfFileName] = {};
	Print("Enter file name: ");
	Read(fileName, LengthOfFileName);

	std::ifstream in(fileName, std::ifstream::binary);

	if (in)
	{
		Clear();
		Data data;
		while (in.read(reinterpret_cast<char*>(&data), sizeof(Data)))
		{
			Add(data);
		}
		in.close();
	}
	else
	{
		Print("There is no such file!\n");
	}
}

void DB::Print()
{
	Print("\tBeautiful Chart\n");
	Print("\t---------------\n\n");
	for (int i = 0; i < size; i++)
	{
		Print(List[i].Name);
		Print("\t|");
		for (int j = 0; j < List[i].Value; j++)
		{
			Print("=");
		}
		Print("\n");
	}
}
