#include "DB.h"

void Read(char* buffer, const int size)
{
	int index = 0;
	int counter = 0;
	char ch;

	ch = _getch();

	while (ch != 13 && index < size - 1)
	{
		if (ch == '\b' && counter > 0)
		{
			_putch(ch);
			_putch(' ');
			_putch(ch);
			index -= 1;
			buffer -= 1;
			counter -= 1;
		}
		else if (ch != '\b' || counter != 0)
		{
			_putch(ch);
			*buffer = ch;
			index++;
			buffer++;
			counter += 1;
		}
		ch = _getch();
	}
	*buffer = 0;
	_putch('\n');
}

void ReadInt(char* buffer, const int size)
{
	int index = 0;
	char ch;
	int counter = 0;

	ch = _getch();
	while (ch != 13 && index < size - 1)
	{
		if (ch == '\b' && counter > 0)
		{
			_putch(ch);
			_putch(' ');
			_putch(ch);
			index -= 1;
			buffer -= 1;
			counter -= 1;
		}
		else if (ch != '\b' || counter != 0)
		{
			if (ch >= '0' && ch <= '9')
			{
				_putch(ch);
				*buffer = ch;
				index++;
				buffer++;
				counter += 1;
			}
		}
		ch = _getch();
	}
	*buffer = 0;
	_putch('\n');
}

void Print(const char* s)
{
	while (*s != 0)
	{
		_putch(*s);
		*s++;
	}
}

int Str2Int(char* buffer)
{
	if (*buffer == 0) return -1;

	char* start = buffer;
	char* end = buffer;
	while (*end >= '0' && *end <= '9')
	{
		end++;
	}
	end -= 1;
	if (end < start) return -1;
	int number = 0;
	int position = 1;
	for (char* p = end; p >= start; p--)
	{
		number += (*p - 48) * position;
		position *= 10;
	}
	return number;
}

void Swap(char* a, char* b)
{
	int temp = *a;
	*a = *b;
	*b = temp;
}

const char* Int2Str(char* str, int num)
{
	char* start = str;
	char* end = str;
	int value = num;

	if (num < 0)
	{
		*str = 0;
	}
	else
	{
		while (value / 10 != 0)
		{
			int character = (value % 10) + '0';
			*end = character;
			end++;
			value /= 10;
		}
		*end = (value % 10) + '0';
		end += 1;
		*end = 0;
		char* s;
		char* e;
		for (s = start, e = end - 1; e > s; s++, e--)
		{
			Swap(s, e);
		}
	}
	return str;
}



int main()
{
	
	int counter = 0;
	DB db;
	bool isRunning = true;
	while (isRunning)
	{
		Print("(l)oad (s)ave (a)dd (q)uit or (p)rint?");
		char ch = _getch();
		_putch(ch);
		counter += 1;
		char enter;
		do
		{
			enter = _getch();
			
			if (enter == '\b' && counter > 0)
			{
				_putch(enter);
				_putch(' ');
				_putch(enter);
				counter -= 1;
			}
			else if (enter != '\b' || counter != 0)
			{
				if (enter != 13)
					ch = enter;
				_putch(enter);
				counter += 1;
			}
			
		} while (enter != 13);

		counter = 0;

		if (enter == 13)
		{
			Print("\n");
			switch (ch)
			{
			case 'a':
			{
				const int size = 50;
				char name[size];
				char value[size];
				Print("Enter Name: ");
				Read(name, size);
				Print("Enter Value: ");
				ReadInt(value, size);
				Data data(name, Str2Int(value));
				db.Add(data);
				break;
			}
			case 's':
				db.Save();
				break;
			case 'l':
				db.Load();
				break;
			case 'p':
				Print("\n");
				db.Print();
				break;
			case 'q':
				isRunning = false;
				break;
			}
		}
	}
	return 0;
}


